%	Copyright (c) 2012-2013, Zhu Ning
%	All rights reserved.
%	
%	Redistribution and use in source and binary forms, with or without
%	modification, are permitted provided that the following conditions are met: 
%	
%	1. Redistributions of source code must retain the above copyright notice, this
%	   list of conditions and the following disclaimer. 
%	2. Redistributions in binary form must reproduce the above copyright notice,
%	   this list of conditions and the following disclaimer in the documentation
%	   and/or other materials provided with the distribution. 
%	
%	THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
%	ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
%	WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
%	DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR
%	ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
%	(INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
%	LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
%	ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
%	(INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
%	SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

function woctave_helper(path_dump, var_dump, var_name, dbg_status, usage)
if (usage == 0)
	
	path_working = pwd;
	fid_woctave_helper = fopen(path_dump, 'wt');
	fprintf(fid_woctave_helper,'pth: %s\n', path_working);
	
	vAns =[];
	bAns = 0;
	
	for i=1:length(var_dump)
			
		if(strcmp(var_dump(i).name, 'ans') == 1)
			vAns = evalin('caller', 'ans');
			bAns = 1;
		end
	end	
		
	for i=1:length(var_dump)
			
				
		if((strcmp(var_dump(i).class, 'struct') == 1) || (strcmp(var_dump(i).class, 'cell') == 1) )
		
			str_eval = disp(' ...');
		
		elseif(var_dump(i).bytes != 0) 
			if(strcmp(var_dump(i).name, 'ans') == 1)
				str_eval = disp(vAns(1));
			else
				str_v = strcat(var_dump(i).name, '(1)');
				str_eval = disp(evalin('caller', str_v));
			end
			
			if((strcmp(num2str(var_dump(i).size), '1   1') == 0) && (strcmp(num2str(var_dump(i).size), '0   0') == 0))
				str_eval = str_eval(1:end-1);
				str_eval = strcat(str_eval, disp(',...'));
			end
		else
				str_eval = disp('[](0x0)');
		
		end
		
				
		fprintf(fid_woctave_helper, 'var: %s,[%s],%d,%s, %s', var_dump(i).name, num2str(var_dump(i).size), var_dump(i).bytes, var_dump(i).class, str_eval);
		
	end
	
	if(bAns == 1)
		assignin('caller', 'ans', vAns);
	else
		evalin('caller', 'clear ans');
	end
	
	dbgmode = isdebugmode;
	fprintf(fid_woctave_helper, 'dbg: %d\n', dbgmode);
	
	% print the debug point status
	
			
	for i = 1:length(dbg_status)
		s_name = getfield(dbg_status(i), 'name');
		s_file = getfield(dbg_status(i), 'file');
		s_line = num2str(getfield(dbg_status(i), 'line'));
		
		fprintf(fid_woctave_helper, 'bpt: %s,%s,%s\n', s_name, s_file, s_line);
	end
	
	idx = strfind(path_dump,'\');
	path_init = path_dump(1:idx(end)-1);
	path_all = path;
	idx = strfind(path_all, path_init);
	path_user = path_all(1:idx+length(path_init));
	fprintf(fid_woctave_helper, 'ptl: %s\n', path_user);
		
	fclose(fid_woctave_helper);
elseif(usage == 1)
	
	
		
	fid_woctave_helper = fopen(path_dump, 'wt');
	
	woctave_explore_var(fid_woctave_helper, var_dump, var_name); 
	fclose(fid_woctave_helper);
	
elseif(usage == 2)	

	fid_woctave_helper = fopen(path_dump, 'wt');
	
	fdisp(fid_woctave_helper, var_dump);
	
	fclose(fid_woctave_helper);
	
elseif(usage == 3)		

	len_var = 1;
	for i = 1: length(size(var_dump))
		len_var = len_var * (size(var_dump))(i);
	end

	y = reshape(var_dump, len_var, 1);
	
	fid_woctave_helper = fopen(path_dump, 'wt');
	
	fdisp(fid_woctave_helper, y);
	
	fclose(fid_woctave_helper);
	
end

		
endfunction